package com.domemusictechnologies.bitattenuator;


import voltage.controllers.*;
import voltage.core.*;
import voltage.core.Jack.JackType;
import voltage.sources.*;
import voltage.utility.*;
import voltage.processors.*;
import voltage.effects.*;
import java.awt.*;

//[user-imports]   Add your own imports here

import static java.lang.Math.pow;

//[/user-imports]


public class BitAttenuator extends VoltageModule
//[user-inheritance]
//[/user-inheritance]
{

public BitAttenuator( long moduleID, VoltageObjects voltageObjects )
{
   super( moduleID, voltageObjects, "Bit Depth Attenuator", ModuleType.ModuleType_CVProcessors, 1.0 );

   InitializeControls();


   canBeBypassed = false;
   SetSkin( "4246f6f53cd84f60a86621667da10518" );
}

void InitializeControls()
{

   knobBitDepth = new VoltageKnob( "Bit Depth", "Bit Depth", this, 0, 24, 0 );
   AddComponent( knobBitDepth );
   knobBitDepth.SetWantsMouseNotifications( false );
   knobBitDepth.SetPosition( 12, 161 );
   knobBitDepth.SetSize( 47, 47 );
   knobBitDepth.SetSkin( "7 edge silver" );
   knobBitDepth.SetRange( 0, 24, 0, false, 25 );
   knobBitDepth.SetKnobParams( 215, 145 );
   knobBitDepth.DisplayValueInPercent( false );
   knobBitDepth.SetKnobAdjustsRing( true );

   inputLeft = new VoltageAudioJack( "Left Input", "Left Input", this, JackType.JackType_AudioInput );
   AddComponent( inputLeft );
   inputLeft.SetWantsMouseNotifications( false );
   inputLeft.SetPosition( 5, 65 );
   inputLeft.SetSize( 25, 25 );
   inputLeft.SetSkin( "Jack Round White Ring" );

   inputRight = new VoltageAudioJack( "Right Input", "Right Input", this, JackType.JackType_AudioInput );
   AddComponent( inputRight );
   inputRight.SetWantsMouseNotifications( false );
   inputRight.SetPosition( 42, 65 );
   inputRight.SetSize( 25, 25 );
   inputRight.SetSkin( "Jack Round Red Ring" );

   textLabel1 = new VoltageLabel( "textLabel1", "textLabel1", this, "Bit Attenuator" );
   AddComponent( textLabel1 );
   textLabel1.SetWantsMouseNotifications( false );
   textLabel1.SetPosition( 3, 0 );
   textLabel1.SetSize( 67, 31 );
   textLabel1.SetEditable( false, false );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel1.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel1.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel1.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel1.SetBorderSize( 1 );
   textLabel1.SetMultiLineEdit( true );
   textLabel1.SetIsNumberEditor( false );
   textLabel1.SetNumberEditorRange( 0, 100 );
   textLabel1.SetNumberEditorInterval( 1 );
   textLabel1.SetNumberEditorUsesMouseWheel( false );
   textLabel1.SetHasCustomTextHoverColor( false );
   textLabel1.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel1.SetFont( "Verdana", 14, false, false );

   textLabel6 = new VoltageLabel( "textLabel6", "textLabel6", this, "Dome Music Technologies" );
   AddComponent( textLabel6 );
   textLabel6.SetWantsMouseNotifications( false );
   textLabel6.SetPosition( 8, 342 );
   textLabel6.SetSize( 56, 18 );
   textLabel6.SetEditable( false, false );
   textLabel6.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel6.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel6.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel6.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel6.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel6.SetBorderSize( 1 );
   textLabel6.SetMultiLineEdit( true );
   textLabel6.SetIsNumberEditor( false );
   textLabel6.SetNumberEditorRange( 0, 100 );
   textLabel6.SetNumberEditorInterval( 1 );
   textLabel6.SetNumberEditorUsesMouseWheel( false );
   textLabel6.SetHasCustomTextHoverColor( false );
   textLabel6.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel6.SetFont( "Verdana", 7, false, false );

   textLabel2 = new VoltageLabel( "textLabel2", "textLabel2", this, "Input" );
   AddComponent( textLabel2 );
   textLabel2.SetWantsMouseNotifications( false );
   textLabel2.SetPosition( 5, 41 );
   textLabel2.SetSize( 62, 30 );
   textLabel2.SetEditable( false, false );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel2.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel2.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel2.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel2.SetBorderSize( 1 );
   textLabel2.SetMultiLineEdit( false );
   textLabel2.SetIsNumberEditor( false );
   textLabel2.SetNumberEditorRange( 0, 100 );
   textLabel2.SetNumberEditorInterval( 1 );
   textLabel2.SetNumberEditorUsesMouseWheel( false );
   textLabel2.SetHasCustomTextHoverColor( false );
   textLabel2.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel2.SetFont( "Verdana", 12, false, false );

   textLabel3 = new VoltageLabel( "textLabel3", "textLabel3", this, "Attenuation" );
   AddComponent( textLabel3 );
   textLabel3.SetWantsMouseNotifications( false );
   textLabel3.SetPosition( 4, 141 );
   textLabel3.SetSize( 65, 20 );
   textLabel3.SetEditable( false, false );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel3.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel3.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel3.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel3.SetBorderSize( 1 );
   textLabel3.SetMultiLineEdit( false );
   textLabel3.SetIsNumberEditor( false );
   textLabel3.SetNumberEditorRange( 0, 100 );
   textLabel3.SetNumberEditorInterval( 1 );
   textLabel3.SetNumberEditorUsesMouseWheel( false );
   textLabel3.SetHasCustomTextHoverColor( false );
   textLabel3.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel3.SetFont( "Verdana", 12, false, false );

   textLabel7 = new VoltageLabel( "textLabel7", "textLabel7", this, "Output" );
   AddComponent( textLabel7 );
   textLabel7.SetWantsMouseNotifications( false );
   textLabel7.SetPosition( 8, 288 );
   textLabel7.SetSize( 56, 19 );
   textLabel7.SetEditable( false, false );
   textLabel7.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel7.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel7.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel7.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel7.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel7.SetBorderSize( 1 );
   textLabel7.SetMultiLineEdit( true );
   textLabel7.SetIsNumberEditor( false );
   textLabel7.SetNumberEditorRange( 0, 100 );
   textLabel7.SetNumberEditorInterval( 1 );
   textLabel7.SetNumberEditorUsesMouseWheel( false );
   textLabel7.SetHasCustomTextHoverColor( false );
   textLabel7.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel7.SetFont( "Verdana", 12, false, false );

   textBitDepth = new VoltageLabel( "Bit Depth Label", "Bit Depth Label", this, "0 Bits" );
   AddComponent( textBitDepth );
   textBitDepth.SetWantsMouseNotifications( false );
   textBitDepth.SetPosition( 5, 208 );
   textBitDepth.SetSize( 62, 18 );
   textBitDepth.SetEditable( false, false );
   textBitDepth.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textBitDepth.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textBitDepth.SetColor( new Color( 255, 255, 255, 255 ) );
   textBitDepth.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textBitDepth.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textBitDepth.SetBorderSize( 1 );
   textBitDepth.SetMultiLineEdit( false );
   textBitDepth.SetIsNumberEditor( false );
   textBitDepth.SetNumberEditorRange( 0, 100 );
   textBitDepth.SetNumberEditorInterval( 1 );
   textBitDepth.SetNumberEditorUsesMouseWheel( false );
   textBitDepth.SetHasCustomTextHoverColor( false );
   textBitDepth.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textBitDepth.SetFont( "Verdana", 12, false, false );

   textGain = new VoltageLabel( "Bit Depth Label_1", "Bit Depth Label_1", this, "-0 dB" );
   AddComponent( textGain );
   textGain.SetWantsMouseNotifications( false );
   textGain.SetPosition( 5, 222 );
   textGain.SetSize( 62, 18 );
   textGain.SetEditable( false, false );
   textGain.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textGain.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textGain.SetColor( new Color( 255, 255, 255, 255 ) );
   textGain.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textGain.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textGain.SetBorderSize( 1 );
   textGain.SetMultiLineEdit( false );
   textGain.SetIsNumberEditor( false );
   textGain.SetNumberEditorRange( 0, 100 );
   textGain.SetNumberEditorInterval( 1 );
   textGain.SetNumberEditorUsesMouseWheel( false );
   textGain.SetHasCustomTextHoverColor( false );
   textGain.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textGain.SetFont( "Verdana", 12, false, false );

   outputJackLeft = new VoltageAudioJack( "Output Left", "Output Left", this, JackType.JackType_AudioOutput );
   AddComponent( outputJackLeft );
   outputJackLeft.SetWantsMouseNotifications( false );
   outputJackLeft.SetPosition( 4, 306 );
   outputJackLeft.SetSize( 25, 25 );
   outputJackLeft.SetSkin( "Jack Round White Ring" );

   outputJackRight = new VoltageAudioJack( "Output Right", "Output Right", this, JackType.JackType_AudioOutput );
   AddComponent( outputJackRight );
   outputJackRight.SetWantsMouseNotifications( false );
   outputJackRight.SetPosition( 42, 306 );
   outputJackRight.SetSize( 25, 25 );
   outputJackRight.SetSkin( "Jack Round Red Ring" );
}



//-------------------------------------------------------------------------------
//  public void Initialize()

//  Initialize will get called shortly after your module's constructor runs. You can use it to
//  do any initialization that the auto-generated code doesn't handle.
//-------------------------------------------------------------------------------
@Override
public void Initialize()
{
   //[user-Initialize]   Add your own initialization code here

   ReadBitDepthKnob(knobBitDepth.GetValue());

   //[/user-Initialize]
}


//-------------------------------------------------------------------------------
//  public void Destroy()

//  Destroy will get called just before your module gets deleted. You can use it to perform any
//  cleanup that's not handled automatically by Java.
//-------------------------------------------------------------------------------
@Override
public void Destroy()
{
   super.Destroy();
   //[user-Destroy]   Add your own module-getting-deleted code here



   //[/user-Destroy]
}


//-------------------------------------------------------------------------------
//  public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )

//  Notify will get called when various events occur - control values changing, timers firing, etc.
//-------------------------------------------------------------------------------
@Override
public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )
{
   //[user-Notify]   Add your own notification handling code between this line and the notify-close comment
   switch( notification )
   {
      case Knob_Changed:   // doubleValue is the new VoltageKnob value
      {
         if (component == knobBitDepth)
         {
            ReadBitDepthKnob(doubleValue);
         }
      }
      break;
   
      case Slider_Changed:   // doubleValue is the new slider value
      {
      }
      break;
   
      case Button_Changed:   // doubleValue is the new button/toggle button value
      {
      }
      break;
   
      case Switch_Changed:   // doubleValue is the new switch value
      {
      }
      break;
   
      case Jack_Connected:   // longValue is the new cable ID
      {
      }
      break;
   
      case Jack_Disconnected:   // All cables have been disconnected from this jack
      {
      }
      break;
   
      case GUI_Update_Timer:   // Called every 50ms (by default) if turned on
      {
      }
      break;
   
      case Object_MouseMove:   // called when mouse is over an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_MouseLeave:  // called when mouse leaves an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonDown:   // called when user left-clicks on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonUp:   // called when user releases left mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonDown:   // called when user releases right mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonUp:   // called when user right-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      case Object_LeftButtonDoubleClick: // called when user left-button double-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      // Less common notifications:
   
      case Named_Timer:   // object contains a String with the name of the timer that has fired
      {
      }
      break;
   
      case Canvas_Painting:   // About to paint canvas.  object is a java.awt.Rectangle with painting boundaries
      {
      }
      break;
   
      case Canvas_Painted:   // Canvas painting is complete
      {
      }
      break;
   
      case Control_DragStart:    // A user has started dragging on a control that has been marked as draggable
      {
      }
      break;
   
      case Control_DragOn:       // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragOff:      // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragEnd:      // A user has ended their drag on a control that has been marked as draggable
      {
      }
      break;
   
      case Label_Changed:        // The text of an editable text control has changed
      {
      }
      break;
   
      case SoundPlayback_Start:   // A sound has begun playback
      {
      }
      break;
   
      case SoundPlayback_End:     // A sound has ended playback
      {
      }
      break;
   
      case Scrollbar_Position:    // longValue is the new scrollbar position
      {
      }
      break;
   
      case PolyVoices_Changed:    // longValue is the new number of poly voices
      {
      }
      break;
   
      case File_Dropped:     // 'object' is a String containing the file path
      {
      }
      break;
   
      case Preset_Loading_Start:   // called when preset loading begins
      {
      }
      break;
   
      case Preset_Loading_Finish:  // called when preset loading finishes
      {
      }
      break;
   
      case Variation_Loading_Start:    // sent when a variation is about to load
      {
      }
      break;
   
      case Variation_Loading_Finish:   // sent when a variation has just finished loading
      {
      }
      break;
   
      case Tempo_Changed:     // doubleValue is the new tempo
      {
      }
      break;
   
      case Randomized:     // called when the module's controls get randomized
      {
      }
      break;
   
      case VariationListChanged:   // sent when a variation gets added, deleted, or renamed, or the variations list gets reordered
      {
      }
      break;
   
      case Key_Press:     // sent when module has keyboard focus and a key is pressed; object is a VoltageKeyPressInfo object
      {
      }
      break;
   
      case Reset:    // sent when the module has been reset to default settings
      {
      }
      break;
   
      case Keyboard_NoteOn:   // sent when a note has been pressed on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Keyboard_NoteOff:   // sent when a note has been released on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Curve_Changed:   // sent when user has edited a curve's value. 'object' will be a VoltageCurve.CurveChangeNotification object.
      {
      }
      break;
   }



   return false;
   //[/user-Notify]
}


//-------------------------------------------------------------------------------
//  public void ProcessSample()

//  ProcessSample is called once per sample. Usually it's where you read
//  from input jacks, process audio, and write it to your output jacks.
//  Since ProcesssSample gets called 48,000 times per second, offload CPU-intensive operations
//  to other threads when possible and avoid calling native functions.
//-------------------------------------------------------------------------------
@Override
public void ProcessSample()
{
   //[user-ProcessSample]   Add your own process-sampling code here

   outputJackLeft.SetValue(inputLeft.GetValue() * dBitMultiplier);
   outputJackRight.SetValue(inputRight.GetValue() * dBitMultiplier);
   
   //[/user-ProcessSample]
}


//-------------------------------------------------------------------------------
//  public String GetTooltipText( VoltageComponent component )

//  Gets called when a tooltip is about to display for a control. Override it if
//  you want to change what the tooltip displays - if you want a knob to work in logarithmic fashion,
//  for instance, you can translate the knob's current value to a log-based string and display it here.
//-------------------------------------------------------------------------------
@Override
public String GetTooltipText( VoltageComponent component )
{
   //[user-GetTooltipText]   Add your own code here



   return super.GetTooltipText( component );
   //[/user-GetTooltipText]
}


//-------------------------------------------------------------------------------
//  public void EditComponentValue( VoltageComponent component, double newValue, String newText )

//  Gets called after a user clicks on a tooltip and types in a new value for a control. Override this if
//  you've changed the default tooltip display (translating a linear value to logarithmic, for instance)
//  in GetTooltipText().
//-------------------------------------------------------------------------------
@Override
public void EditComponentValue( VoltageComponent component, double newValue, String newText )
{
   //[user-EditComponentValue]   Add your own code here



   //[/user-EditComponentValue]
   super.EditComponentValue( component, newValue, newText );
}


//-------------------------------------------------------------------------------
//  public void OnUndoRedo( String undoType, double newValue, Object optionalObject )

//  If you've created custom undo events via calls to CreateUndoEvent, you'll need to
//  process them in this function when they get triggered by undo/redo actions.
//-------------------------------------------------------------------------------
@Override
public void OnUndoRedo( String undoType, double newValue, Object optionalObject )
{
   //[user-OnUndoRedo]   Add your own code here



   //[/user-OnUndoRedo]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformation()

//  Gets called when the module's state gets saved, typically when the user saves a preset with
//  this module in it. Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformation()
{
   //[user-GetStateInformation]   Add your own code here



   return null;
   //[/user-GetStateInformation]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformation(byte[] stateInfo)

//  Gets called when this module's state is getting restored, typically when a user opens a preset with
//  this module in it. The stateInfo parameter will contain whatever custom data you stored in GetStateInformation().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformation(byte[] stateInfo)
{
   //[user-SetStateInformation]   Add your own code here



   //[/user-SetStateInformation]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformationForVariations()

//  Gets called when a user saves a variation with this module in it.
//  Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformationForVariations()
{
   //[user-GetStateInformationForVariations]   Add your own code here



   return GetStateInformation();
   //[/user-GetStateInformationForVariations]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformationForVariations(byte[] stateInfo)

//  Gets called when a user loads a variation with this module in it.
//  The stateInfo parameter will contain whatever custom data you stored in GetStateInformationForVariations().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformationForVariations(byte[] stateInfo)
{
   //[user-SetStateInformationForVariations]   Add your own code here
   SetStateInformation(stateInfo);



   //[/user-SetStateInformationForVariations]
}


// Auto-generated variables
private VoltageAudioJack outputJackRight;
private VoltageAudioJack outputJackLeft;
private VoltageLabel textGain;
private VoltageLabel textBitDepth;
private VoltageLabel textLabel7;
private VoltageLabel textLabel3;
private VoltageLabel textLabel2;
private VoltageLabel textLabel6;
private VoltageLabel textLabel1;
private VoltageAudioJack inputRight;
private VoltageAudioJack inputLeft;
private VoltageKnob knobBitDepth;


//[user-code-and-variables]    Add your own variables and functions here

// Constants

private final double FIVE_TO_ONE_VOLTS = 0.2;
private final double ONE_TO_FIVE_VOLTS = 5.0;

// Variables

private double dBitDepth;
private double dBitMultiplier;
private double dBitGainDecibels;
private String strBitDepth;
private String strGainDecibels;

// Objects

private SmoothValue smoothNoiseLevel = new SmoothValue();

// Functions

void ReadBitDepthKnob(double bits)
{
   int iDisplayBitDepth;
   
   dBitDepth = bits;
   dBitMultiplier = pow (2.0, (-1.0 * dBitDepth));
   
   iDisplayBitDepth = (int)bits;   
   strBitDepth = String.format("%d Bits", iDisplayBitDepth);
   textBitDepth.SetText (strBitDepth);
   
   strGainDecibels = String.format("-%d dB", iDisplayBitDepth * 6);
   textGain.SetText (strGainDecibels);
}


//[/user-code-and-variables]
}

 